let presetItemHeight = 34;

markup.push({
	"PresetsWindow": {
		nsClass: "GXWindow",
		gxWindowTitle: "Presets",
		gxInitialWindowSize: "320, 250",
		gxInitialWindowPosition: "0.3, 0.3",
		gxBackColor: "name:invisible",
		gxInvisibleContentView: true,
		gxContentView: "PresetsWindowContentView",
		gxSheetHostTarget: "MainAppPopoverSheetHost",
	},
	PresetsWindowContentView: {
		nsClass: "GXSettingsView",
		gxWantsLayer: true,
		gxBackPainter: {
			nsClass: "GXPainter",
			gxFillColor: "name:background",
			gxEdgeInsets: "0,0,0,12", // Inset bottom so rounded corners of footer look correct
		},
		gxLayout: "V:|-5-[headerView]-5-[div(1)]-0-[presetsScroller]-0-[bottomBar(44)]|",
		gxChildViews: {
			headerView : {
				"+" : "LabelView.size14.bold.left.fontColor",
				gxIntrinsicHeight: 20,
				gxIntrinsicWidth: -1,
				gxLayout: ["H:|-15-[self]-0-|"],
				gxValueKeyPath: "presetsGroup.displayName"
			},
			div: {
				"+": "PanelDivider",
			},
			presetsScroller: {
				nsClass: "GXScrollView",
				gxBackColor: "name:background",
				gxVScrollbar: "ScrollBarView",	// vertical scroller only
				gxVScrollbarWidth: 10,
				gxAutoHidesScrollers: true,
				gxLayout: [ "H:|-0-[self]-0-|", "V:[self(<=150)]" ],
				gxDocumentView: {
					nsClass: "GXListView",
					gxViewName: "presetsList",
					gxCollapsible: false,
					listTopHeight: 5,
					listBottomHeight: 3,
					axTitle: "Presets List",
					gxLayout: [ "H:|-0-[self]-0-|", `V:|-0-[self(>=${presetItemHeight}@700)]-0@700-|` ],
					gxChildViews: {
						emptyView: {
							"+": "LabelView",
							gxLayout: ["H:|[self]|"],
							gxIntrinsicHeight: presetItemHeight,
							gxIntrinsicWidth: -1,
							gxDefaultValue: "No Presets"
						},
					}
				}
			},
			bottomBar: {
				nsClass: "GXSettingsView",
				gxWantsLayer: true,
				gxValueKeyPath: "",
				gxBackPainter: {
					nsClass: "GXRoundRectPainter",
					gxCornerRadii: "0,0,8,8",
					gxFillColor: "name:mainPopoverFooterFill"
				},
				gxLayerZPosition: 1,
				gxLayout: [ "H:|[self]|",
				"H:|[div]|",
				"H:[dismissSheetBtn]-14-|&alignCenterY",
				"H:[self]-(<=0)-[dismissSheetBtn]&alignCenterY" ],  // center vertically
				gxChildViews: {
					dismissSheetBtn: {
						"+": "ButtonView",
						gxValueKeyPath: "dismissSheetBtn",
						gxBackPainter: {
							"+" : "FlatButtonBack.green",
							"on" : {
								gxFillColor: "name:fullGreen",
								gxAddStyles: ["pressed"]
							}
						},
						gxForePainter: "FlatButtonFore.green",
						gxTitle: "Done",
						gxKeyEquivalent: "\r",
						gxIntrinsicHeight: 23
					},
					div: {
						"+": "PanelDivider",
					},
				}
			}
		}
	},
	
	PresetItemView: {
		nsClass: "GXSettingsView",
		gxIntrinsicWidth: -1,
		gxIntrinsicHeight: presetItemHeight,
		gxBackPainter: "PresetItemBg",
		drawsSelected: true,
		selectable: true,
		gxChildViews: {
			"sparkline" : {
				"+": "ImageView",
				gxFrameRect: "23,6,23,23",
				gxValueKeyPath: "sparkline",
 				"gxImagePainter": {
					"+": "ImagePainter",
					gxTintColor: "name:fontColor",
				},
				axIsIgnored: true,
			},
			presetName: {
				"+": "BaseTextField",
				gxBackPainter: null,
				gxBaselineOffset: 2,
				gxValueKeyPath: "name",
				gxFrameRect: "50,5,225,23",
				gxSelectionColor: "name:pluginFrame",
				"gxTextPainter": {
					"+" : "TextFieldFore",
					gxBackColor: "name:invisible",
				},
				drawsSelected: true,
				gxDrawsFocusRing: false,
			},
			"deleteBtn": {
				"+" : "deleteButton",
				gxFrameRect: "279,5,20,23",
				axTitle: "Preset Delete",
			},
		}
	},
	
	PresetItemBg: {
		nsClass: "GXRoundRectPainter",
		gxCornerRadius: 6,
		gxEdgeInsets: "14, 2, 4.5, 4",
		gxFillColor: "name:pluginFill",
		gxFrameColor: "name:pluginFrame",
	}
	
});

markup.push({
	Equalizer10Presets: {
		nsClass: "GEPresetsGroup",
		gxTitle: "Custom EQ Presets",
		gxPresetValueKeys: [ "node.band0", "node.band1", "node.band2", "node.band3", "node.band4", "node.band5", "node.band6", "node.band7", "node.band8", "node.band9" ]
	},
});
