// -------------------------------------------------------------------
// GX Class Names

var GXButtonView = "GXButtonView";
var GXDrawView = "GXDrawView";
var GXPathSelector = "GXPathSelector";
var GXFormatter = "GXFormatter";
var GXPainter = "GXPainter"
var GXPopover = "GXPopover";
var GXPopoverBackground = "GXPopoverBackground";
var GXStyledString = "GXStyledString";
var GXWindow = "GXWindow";
var GXWindowController = "GXWindowController";
var GXSettingsView = "GXSettingsView";
var GXArtView = "GXArtView";
var GXDatePicker = "GXDatePicker";
var GXImageView = "GXImageView";
var GXLabelView = "GXLabelView";
var GXListView = "GXListView";
var GXPasswordField = "GXPasswordField";
var GXPopupMenuView = "GXPopupMenuView";
var GXScroller = "GXScroller";
var GXSliderView = "GXSliderView";
var GXSpinnerView = "GXSpinnerView";
var GXSwitchView = "GXSwitchView";
var GXTextField = "GXTextField";
var GXTokenField = "GXTokenField";
var GXNumberField = "GXNumberField";
var GXTextView = "GXTextView";
var GXLevelMeter = "GXLevelMeter";
var GXMeterLayer = "GXMeterLayer";
var GXDrawLayer = "GXDrawLayer";
var GXSpecMeter = "GXSpecMeter";
var GXSpecMeter = "GXSpecMeter";
var GXVUMeter = "GXVUMeter";
var GXDropView = "GXDropView";
var GXRoundRectPainter = "GXRoundRectPainter";
var GXScrollView = "GXScrollView";
var GXImagePainter = "GXImagePainter";
var GXTimeFormatter = "GXTimeFormatter";
var GXScaledFormatter = "GXScaledFormatter";


// -------------------------------------------------------------------

var nsClass = "nsClass";		// the class to instantiate

var gxValueKeyPath = "gxValueKeyPath";	// the main 'value' this object displays or controls

// for all views ------------------------------------------------

var gxChildViews = "gxChildViews";	// child views to load within this view
var gxLayout = "gxLayout";	// autolayout contraints to add

var gxFrameRect = "gxFrameRect";	// mostly useless. autolayout contraints cause it to be ignored
var gxViewName = "gxViewName";

var gxCanDrawSubviewsIntoLayer = "gxCanDrawSubviewsIntoLayer";	// tricky, but important for quality text rendering of labels
var gxWantsLayer = "gxWantsLayer";
var gxLayerZPosition = "gxLayerZPosition";	// controls visual front to back order of layers

var gxLayerColor = "gxLayerColor";	// fills layer, painting whole rectanguler background (for special cases)
var gxBackColor = "gxBackColor";		// fills whole background (no layer needed), useful for labels sometimes.

var gxToolTip = "gxToolTip";
var gxToolTipKeyPath = "gxToolTipKeyPath";

var gxDrawsSelected = "gxDrawsSelected";
var gxDrawsFocused = "gxDrawsFocused";

// hiding or disabling depending on model state (some can override others)
var gxDisableOnNil = "gxDisableOnNil";
var gxDisableOnKey = "gxDisableOnKey";
var gxShowOnSelection = "gxShowOnSelection";
var gxShowOnKey = "gxShowOnKey";
var gxHideOnNilValue = "gxHideOnNilValue";

var gxEnclosureRect = "gxEnclosureRect";	 // complicated - rarely used, may go away.
var gxAddViewBelow = "gxAddViewBelow";	// add below siblings (crude control of front to back order)

var gxNextKeyView = "gxNextKeyView";	// for controlling next control when user tabs ('key' as in 'key view loop')

// shortcut to add a label for a control (think label on a field or slider)
var gxLabelText = "gxLabelText";
var gxLabelTemplate = "gxLabelTemplate";

// shortcut to add a readout for a control (think slider readout)
var gxReadoutKeyPath = "gxReadoutKeyPath";
var gxReadoutTemplate = "gxReadoutTemplate";

// accessibility
var axIsIgnored = "axIsIgnored";
var axRoleDescription = "axRoleDescription";
var axTitle = "axTitle";
var axTitleKeyPath = "axTitleKeyPath";
var axDescription = "axDescription";
var axDescriptionKeyPath = "axDescriptionKeyPath";
var axHelp = "axHelp";
var axHelpKeyPath = "axHelpKeyPath";

//MARK: GXDrawView

// figures used by autolayout
var gxIntrinsicWidth = "gxIntrinsicWidth";
var gxIntrinsicHeight = "gxIntrinsicHeight";
var gxBaselineOffset = "gxBaselineOffset";

// painter substyles used: 'disabled' + 'selected'
var gxBackPainter = "gxBackPainter";

var gxConsumeMouseClick = "gxConsumeMouseClick";	// if clicked, click does nothing. usually it'd go 'through'

// MARK: GXSettingsView

// a few special flags for state (its mostly just history that they lack 'gx' prefixes)
var selectable = "selectable";
var drawsSelected = "drawsSelected";
var doubleClickAction = "doubleClickAction";
var multipleSelection = "multipleSelection";
var draggable = "draggable";

// context menu support
var gxMenuItems = "gxMenuItems";
var gxMenuItemsKeyPath = "gxMenuItemsKeyPath";
var gxSelectOnContextMenu = "gxSelectOnContextMenu";

// settings views can 'expand' with an extra view (see AH3 recbin and timers)
var gxExpansionView = "gxExpansionView";
var gxExpandedHeight = "gxExpandedHeight";	// uses gxIntrinsicHeight when collapsed

var gxAlwaysUpdate = "gxAlwaysUpdate"; // always update even when model isn't marked as changed. expensive, rarely needed or used.

// MARK: GXLabelView

var gxIgnoreMouseClick = "gxIgnoreMouseClick";

var gxDefaultValue = "gxDefaultValue";
var gxClickValue = "gxClickValue";
var gxFormatter = "gxFormatter";
var gxAnimateOnKey = "gxAnimateOnKey";
var gxSelectedTitleStyle = "gxSelectedTitleStyle";

var gxForePainter = "gxForePainter";
var gxExtraPainter = "gxExtraPainter";
var gxIconBaseName = "gxIconBaseName";	// if icon provided it is fed to forepainter

// MARK: GXButtonView

var gxOperateOnMouseDown = "gxOperateOnMouseDown";	// act on mousedown rather than normal mouseup (rarely used, defaults to false)
var gxOperateOnMouseUp = "gxOperateOnMouseUp";		// defaults to true

var gxAction = "gxAction";
var axCheckboxRole = "axCheckboxRole";

var gxTitle = "gxTitle";
var gxTitleKeyPath = "gxTitleKeyPath";

var gxIcon = "gxIcon";
var gxIconKeyPath = "gxIconKeyPath";

var gxPressedToolTip = "gxPressedToolTip";	// swaps with gxToolTip when not pressed

// MARK: GXSliderView

var gxVertical = "gxVertical";
var gxRangeMin = "gxRangeMin";
var gxRangeMax = "gxRangeMax";

var gxIgnoreTrackClicks = "gxIgnoreTrackClicks";
var gxAlwaysSendClicks = "gxAlwaysSendClicks";

var gxEndGap = "gxEndGap";			// how close the thumb gets to the end (usually half visual thumb size)
var gxTrackOffset = "gxTrackOffset";		// position of track from top or left, if not given, track is centered
var gxDetentSnapDistance = "gxDetentSnapDistance";
var gxActiveOnKey = "gxActiveOnKey";

// detents
var gxDetents = "gxDetents";
var gxDetentPainter = "gxDetentPainter";
var gxDetentLabelPainter = "gxDetentLabelPainter";
var gxDetentStrings = "gxDetentStrings";

// track painter uses substyles 'active' or 'disabled' + is used twice,
// with substyle 'on' and no substyle either side of thumb.
var gxTrackPainter = "gxTrackPainter";
// knob painter uses substyles 'active' or 'disabled' + selected
var gxKnobPainter = "gxKnobPainter";

var gxKeystrokeStepSize = "gxKeystrokeStepSize";
var gxKeystrokeStepSizeKeyPath = "gxKeystrokeStepSizeKeyPath";

var axValueDescriptionKeyPath = "axValueDescriptionKeyPath";
var axFormatter = "axFormatter";

// MARK: GXListView

var gxLayoutSubviews = "gxLayoutSubviews";
var gxLayoutHorizontally = "gxLayoutHorizontally";

var gxCollapsible = "gxCollapsible";
var gxCollapsed = "gxCollapsed";

var gxScrollerFillColor = "gxScrollerFillColor";		// for main rectangle behind content
var gxScrollBarFillColor = "gxScrollBarFillColor";	// for behind the scrollbars

var gxFloatingGroupHeaders = "gxFloatingGroupHeaders";

// spacing top and bottom etc
var listTopHeight = "listTopHeight";
var listBottomHeight = "listBottomHeight";
var listMinimumHeight = "listMinimumHeight";

// MARK: GXDropView

var gxStrokeColor = "gxStrokeColor";

// MARK: GXScrollView

var gxVScrollbar = "gxVScrollbar";
var gxHScrollbar = "gxHScrollbar";
var gxDocumentView = "gxDocumentView";
var gxMinKnobLength = "gxMinKnobLength";

// MARK: GXTextField

var gxTextStyle = "gxTextStyle";
var gxDisabledAlphaColor = "gxDisabledAlphaColor";
var gxInsertionPointColor = "gxInsertionPointColor";
var gxSelectionColor = "gxSelectionColor";
var gxPlaceholderStyle = "gxPlaceholderStyle";
var gxEditingKeyPath = "gxEditingKeyPath";
var gxEditable = "gxEditable";

// MARK: GXWindow

var gxWindowStyleMask = "gxWindowStyleMask";
var gxWindowTitle = "gxWindowTitle";

var gxCanFullScreen = "gxCanFullScreen";
var gxWindowMaxSize = "gxWindowMaxSize";
var gxWindowMinSize = "gxWindowMinSize";

var gxInitialWindowSize = "gxInitialWindowSize";
var gxInitialWindowPosition = "gxInitialWindowPosition";

var gxSavedWindowStateKey = "gxSavedWindowStateKey";

var gxContentView = "gxContentView";	  // single view that contains all other views in the window

// MARK: GXPainter

var gxEdgeInsets = "gxEdgeInsets";
var gxFillColor = "gxFillColor";

var gxDefaultSize = "gxDefaultSize";		// only rarely used, like for slider thumbs

// MARK: GXRoundRectPainter

var gxCornerRadii = "gxCornerRadii";		// radii, in clockwise order (topLeft, topRight, bottomRight, bottomLeft)
var gxCornerRadius = "gxCornerRadius";	// if no gxCornerRadii, use this one value for all corners
var gxStrokeWidth = "gxStrokeWidth";

var gxFrameColor = "gxFrameColor";		// single pixel frame color (no stroke width setting - surprising, can be added)
var gxHiliteColor = "gxHiliteColor";		// single pixel top edge inner hilite (or whatever its called).

var gxFillEndColor = "gxFillEndColor";	// if provided, fill becomes a gradient from gxFillColor to gxFillEndColor

var gxShadow = "gxShadow";	// shadow behond the fill (not the stroke)

// MARK: GXStringPainter

var gxFont = "gxFont";				// an actual font object (usually created and cached for you based on family, size, weight below)
var gxFontFamily = "gxFontFamily";	// name of font family, eg "Helvetica", defaults to system font, which can be explicity used as "System"
var gxFontSize = "gxFontSize";		// number for font size
var gxFontWeight = "gxFontWeight";	// Font weights according to apple: From -1.0 to 1.0
// -0.8  UltraLight
// -0.6  Thin
// -0.4  Light
// 0     Regular
// 0.23  Medium
// 0.3   Semibold
// 0.4   Bold
// 0.56  Heavy
// 0.62  Black

var gxFontColor = "gxFontColor";

var gxFontShadow = "gxFontShadow";	// r, g, b, a, xoffset, yoffset, angle

var gxLineBreakMode = "gxLineBreakMode";	// defaults to 0=word wrap. 4=truncate tail. 5=trunc middle etc

var gxHAlign = "gxHAlign";	// horizontal alignment 0 to 1, eg 0=left, 0.5=center, 1=right (overrides gxAlignment)
var gxVAlign = "gxVAlign";	// vertical alignment, 0 to 1 (overrides gxAlignment)
var gxAlignment = "gxAlignment";	// older, gxHAlign and gxVAlign combined, probably just use them...

var gxFontKerning = "gxFontKerning";
var gxLineSpacing = "gxLineSpacing";
var gxFontExpansion = "gxFontExpansion";

var gxIconSpacing = "gxIconSpacing";	// space between icon and text
var gxIconAlpha = "gxIconAlpha";	// 0 to 1. var the icon be alphaed

// MARK: GXImagePainter

var gxImage = "gxImage";
var gxTintColor = "gxTintColor";

// MARK: GXDrawLayer

var gxNeedsDisplayOnResize = "gxNeedsDisplayOnResize";
var gxContentsCenter = "gxContentsCenter";
