markup.push({ 
    MenuPopoverHeaderView: {
        nsClass: GXSettingsView,
		gxConsumeMouseClick: true, // Make sure clicking the header doesn't cause any open plugin to be hidden
		gxValueKeyPath: "",
		gxBackPainter: {
			nsClass: GXRoundRectPainter,
			gxFillColor: "name:mainPopoverHeaderFill",
			gxEdgeInsets: "1,0.5,2.5,0",
			gxCornerRadii: "8,8,0,0"
		},
        gxLayout: [
            "H:|-22-[self]-19.5-|",
            `V:|-12-[self(${Constants.PopoverHeaderHeight})]`,
            "V:|-0-[trialButton(28)]",
            "H:[trialButton(100)]-70-|",
            "H:|-20-[pinBtn(23)]",
            "V:|-7-[appTitle(30)]",
            "V:|-9-[pinBtn(23)]",
            "V:|-6-[optionsButton(30)]",
            "H:[optionsButton(30)]-22-|",
            "V:[self]-(<=0)-[center]&alignCenterX",
        ],
        gxChildViews: {
			"overlay" : {
				"+" : "DesatOverlay",
				gxBackPainter : {
					"+" : "DesatOverlayBackPainter",
					gxEdgeInsets: "1,0,2.5,0",
					gxCornerRadii: "8,8,0,0"
				}
			},
            pinBtn: {
                nsClass: GXButtonView,
                gxLayerZPosition: 2,
				gxViewFlipped: false,
                gxBackPainter: {
                    "+": "ImagePainter.icon-pin",
					gxTintColor: "name:white",
                },
                gxValueKeyPath: "pinnedBtn",
                gxToolTip: "Pin this popover above all windows on the system",
                gxPressedToolTip: "Unpin this popover",
                axTitle: "Pin",
            },
            appTitle: {
                "+": "LabelView",
                gxLayerZPosition: 5,
                gxIntrinsicWidth: -1,
                gxLayout: ["H:|-[self]-|"],
                gxForePainter: {
                    "+": "LabelFore.center.size16.bold.white",
                    gxIconAlpha: 0.3,
                },
                gxDefaultValue: "SoundSource",
            },
            trialButton: {
                "+": "ButtonView",
                gxIntrinsicWidth: -1,
                gxLayerZPosition: 20,
                gxBackPainter: {
                    "+": "ControlBack",
                    gxFrameColor: null,
                    gxEdgeInsets: "1,1,1,1",
                    gxCornerRadii: "0,0,6,6",
                    gxFillColor: "name:trialButtonOrange"
                },
                gxHideOnNilValue: true,
                gxValueKeyPath: "windowController.trialBtn",
                gxForePainter: {
                    "+": "ControlFore.white",  
                },
                gxTitle: "Trial Mode"
            },
            optionsButton: {
                nsClass: "GXPopupMenuView",
				axTitle: "Options",
                gxLayerZPosition: 2,
				gxViewFlipped: false,
                gxValueKeyPath: "optionsMenuItemSelected",
				gxPullsDown: true,
                gxMenuItems: [
                    seperatorItem(),
                    menuItem("Preferences...", null, ","), 
                    menuItem("License..."),
					merge(menuItem("Purchase SoundSource..."), { "gxHideOnKey": "hidePurchaseMenuItem" }),
                    seperatorItem(),
                    menuItem("System", null, "", [ menuItem("Open Sound Preferences"), menuItem("Open Audio MIDI Setup")] ),
                    seperatorItem(),
					menuItem("Documentation", null, "", [
														 menuItem("Manual"),
														 menuItem("Quick Tour"),
														 menuItem("Release Notes"),
														]),
					menuItem("Contact Support..."),
					menuItem("About SoundSource"),
					seperatorItem(),
					menuItem("Uninstall ACE..."),
                    merge(menuItem("Reinstall ACE..."), { "gxIsAlternate": true }),
                    seperatorItem(),
                    menuItem("Quit SoundSource", null, "q"), 
                ],
                gxBackPainter: {
                    "+": "ImagePainter.icon-preferences",
                    gxTintColor: "name:white", 
                },
            }, 	
            center: {
                nsClass: GXDrawView,
            }
        }
    },

    AppPopover: {
		nsClass: "SoundSource.TCAppPopover",
		gxValueKeyPath: "",
		gxBackColor: "name:mainPopoverHeaderFill", // Important for getting the popover point to have the correct color
		gxWantsLayer: false,
		gxScreenInset: "0,0,-12,0",
		gxShadow: "{0, 0, 0, 0.2}, {0, -3}, 10",
		gxHiliteColor: "name:invisible",
		gxHeaderView: "MenuPopoverHeaderView",
		gxEdgeInsets: "10.5,0,10.5,0.5",
		gxValueKeyPath: "uiState",
		axTitle: "SoundSource",
		axRoleDescription: "Main application window",
		gxSheetHostIdentifier: "MainAppPopoverSheetHost",
		// Vertical contraints are altered in TCAppPopover.swift to make sure
		// the popover doesn't expand past the current screen size.
        gxLayout: [
            `H:|-23-[self(${Constants.popoverWidth})]-22-|`,
			"V:|-10-[self]-12-|",
            "V:[footer(45)]-0-|"
        ],
        gxChildViews:
        {
			"overlay" : {
				"+" : "DesatOverlay",
				gxBackPainter : {
					"+" : "DesatOverlayBackPainter",
					gxEdgeInsets: "0,40,0,45",
				}
			},
            sourcesScrollView: {
                nsClass: GXScrollView,
                gxBackColor: "name:background",
				gxAutohidesScrollers: true,
				axIsIgnored: true,
                gxWantsLayer: true, // Do not delete! Vital for getting layers to look right on older systems.
                gxVScrollbar: "ScrollBarView",
				gxVScrollbarWidth: 10,
                gxLayout: [
                    "H:|-0-[self]-0-|",
                    "V:|-43-[self]-40-|",
					"V:|-0-[sourceListContainerView]-(0@550)-|"
                ],
                gxAddViewBelow: true,
                gxDocumentView: {
                    nsClass: GXDrawView,
                    gxViewName: "sourceListContainerView",
                    gxLayout: [
                        "H:|-0-[self]-0-|",
                        "V:|-7-[systemDevicesSourceList]-0-[applicationSourceList]-10-|",
						"V:[noApplicationsView(36)]-10-|",
                    ],
                    gxChildViews: {
                        systemDevicesSourceList: sourceListView("System", "Volume", "Boost", "Device"),
                        applicationSourceList: sourceListView("Applications", " ", " ", "Redirect Audio To"),
						noApplicationsView: {
							nsClass: "GXDrawView",
							gxLayout : [ "H:|[self]|" ], 
							gxShowSpeedSeconds: 0.3,
							gxChildViews: {
								itemView: {
									"+": "LabelView.size14.fullGreen.bold",
									gxIntrinsicHeight: 40,
									gxDefaultValue: "\u{2193} Start controlling audio on a per-application level!",
									gxLayout: [ "H:|-55-[self]" ],
								}
							}
						},
                    },
                    gxLayoutHorizontally: true,
                    axTitle: "Audio Source List",
                    axHelp: "List of all system devices and appliction sources",
                },

            },
            footer: {
                nsClass: GXDrawView,
                gxLayerZPosition: 20,
                gxBackPainter: {
                    nsClass: GXRoundRectPainter,
                    gxCornerRadii: "0,0,8,8",
                    gxFillColor: "name:mainPopoverFooterFill"
                },
                gxLayout: [
                    "H:|-0-[self]-0-|",
                    "V:[addAppPopup]-10-|",
                ],
                gxChildViews: {
					"overlay" : {
						"+" : "DesatOverlay",
						gxBackPainter : {
							"+" : "DesatOverlayBackPainter",
							gxCornerRadii: "0,0,8,8"
						}
					},
					"div" : "PanelDivider",
                    "addAppPopup": {
                        "+": "FlatButtonPopup.green.down",
						gxForePainter: {
							"+" : "FlatButtonFore",
							gxEdgeInsets: "-7,-1,0,0"
						},
						gxValueKeyPath: "addApp",
                        nsClass: "TCAppPopupView",
						gxToolTip: "Add an application to the list of sources you wish to control",
                    }
                }
            }
        }
    },
}); 
