markup.push({
	GenericAUPopover: {
		nsClass: "SoundSource.TCPluginPopover",
		gxValueKeyPath: "uiState.popoverState",
		gxBackColor: "name:genericPluginPopoverFrame",
		gxShadow: "{0, 0, 0, 0.2}, {0, 0}, 5",
		gxHiliteColor: "name:invisible",
		axRoleDescription: "Plugin Window",
		gxLayout: [
			"H:|-10-[auView]-10-|",
			"V:|-20-[auView]-10-|", 
			"H:|-10-[self]-10-|",
			"V:|-20-[self]-10-|",
		],
		gxChildViews: {
			auView: {
				nsClass: "GEAudioUnitView",
				gxIntrinsicWidth: 200,
				gxIntrinsicHeight: 200,
				gxBackPainter: "AudioUnitBack",
				gxLoadingSpinnerColor: "name:fontColor",
				gxUpdateModelOnMouseDrag: true,
			},
			title: {
				"+": "LabelView",
				gxDefaultValue: "Loading...",
				gxForePainter: {
					"+": "LabelFore.size14.bold",
					gxFontColor: "name:fontColor",
				},
				gxValueKeyPath: "node.descriptor.name", 
				gxLayout: [ "H:|-10-[self]-10-|", "V:|-(-3)-[self(18)]" ],
				gxIntrinsicWidth: -1,
			},
		}
	},  

	AudioUnitBack: {
		nsClass: GXRoundRectPainter,
		gxCornerRadius: 6,
		gxFillColor: "name:genericPluginPopoverFill",
		gxEdgeInsets: "10,0,10,10"
	},

	// --------------------------------------------------
	// MARK: generic AU view controls

	GenericAUSliderItem: {
		nsClass: "GXDrawView",
		gxLayout: [ "H:|-10-[label(160)]-[slider(190)]-[readout(100)]-20-|&alignBaseline",
				   	"V:|-4-[slider]-3-|" ],
		gxChildViews: {
			slider: {
				"+": "SliderView"
			},
			label: {
				"+": "LabelView.right.fontColor.size13"
			},
			readout: {
				"+": "SliderValueLabel",
				gxAlignment: "{0, 0.5}"
			}
		}
	}, 

	GenericAUSwitchItem: {
		nsClass: "GXDrawView",
		gxLayout: [ "H:|-10-[label(160)]-11-[switch]-10-|&alignBaseline",
				   	"V:|-4-[switch]-3-|" ],
		gxChildViews: {
			switch: {
				nsClass: "SoundSource.TCGXSwitchView",
				gxValueKeyPath: "enabled", 
				gxImageBaseName: "switch",
				gxLayout: [ "H:[self(42)]" ],
			},
			label: {
				"+": "LabelView.right.fontColor.size13"
			}
		}
	},

	GenericAUPopupMenuItem: {
		nsClass: "GXDrawView",
		gxLayout: [ "H:|-10-[label(160)]-[popupMenu(190)]-10-|&alignBaseline",
				   	"V:|-4-[popupMenu]-3-|" ],
		gxChildViews: {
			popupMenu: {
				nsClass: "GXPopupMenuView",
				gxIntrinsicHeight: 25,
				gxBackPainter: {
					"+" : "PopupMenuBack",
					gxFillColor: "name:controlBackFill"
				},
				gxForePainter: {
					"+": "ControlFore.size12.fontColor.left",
					gxEdgeInsets: "10,0,0,0",
				},
				gxExtraPainter: "PopupArrows",
				gxHideOnNilValue:false, 
			},
			label: {
				"+": "LabelView.right.fontColor.size13"
			}
		}
	},
  
	SliderValueLabel: {
		"+": "LabelView.right.fontColor.size105",
		gxSpacingPixels: "{1, 2, 1, -1}",
		gxVAlign: 1,
		gxAlignment: "{1, 1}",
		gxPosition: "{1, 0}",
		gxClickValue: 0
	},
	
})
