markup.push({
    // MARK: slider view
    "SliderView": {
        nsClass: "SoundSource.TCSliderView",
		gxIgnoreScrollWheel: false,
		gxDrawsFocusRing: true,
        gxIntrinsicHeight: 23,
        gxBaselineOffset: 6,
        gxEndGap: 10,
		gxTrackOffset:  1,
        gxDrawsFocused: true,
        gxDisableOnNil: false,
        "gxAllowNumericEntry": false,
		gxDrawsSelected: true,
        gxTrackPainter: "SliderTrack",
        gxKnobPainter: "SliderKnob",
        gxLabelTemplate: "SliderLabel",
        gxDetentPainter:  "SliderDetents",
        gxReadoutTemplate: "SliderReadout.percentage",
    },

    // standard label for a slider
    "SliderLabel": {
        "+": "LabelView.right.fontColor.size13",
    },

    // standard readout for a slider
    "SliderReadout": {
        "+": "LabelView",
        gxForePainter: {
            "+": "LabelFore.right.fontColor.size11",
            "disabled": {
                // prevent drawing when disabled by making empty rect
                gxEdgeInsets: "999,999,999,999"
            },
        },
        gxEdgeInsets: "0,-4,0,4",
        gxDefaultValue: "",
        gxIntrinsicWidth: 48,
        gxIntrinsicHeight: 19,
        gxVAlign: 1,
        gxClickValue: 0.5,
        "fractionalSeconds": {
            gxFormatter: { nsClass: GXTimeFormatter, "fractionalSeconds": true },
        },
        "percentage": {
            gxFormatter: { nsClass: GXScaledFormatter, "scale": 100, "format": "%.0f%%" },
        },
    },

    // MARK: slider painters

    "SliderTrack":
    {
        nsClass: GXRoundRectPainter,
        gxDefaultSize: "4,4",    // default size of track determines track width!
        gxCornerRadii: "1, 1, 1, 1",
        gxEdgeInsets: "5,0,5,0",     // 'off' track (since not on) is inset on right
        gxFrameColor: "name:darkMinty",
        gxFillColor: "name:darkMinty",
		gxStrokeWidth: 1,
        "on": {
            gxCornerRadii: "1, 1, 1, 1",
            gxEdgeInsets: "5,0,0,0",     // on track is inset on left
            gxFrameColor: "name:fullGreen",
            gxFillColor: "name:fullGreen"
        },
        "disabled": {
            // prevent drawing using zero size when disabled
            gxFrameColor: "name:darkMinty",
            gxFillColor: "name:darkMinty"
        },
        "muted": {
            gxCornerRadii: "1, 1, 1, 1", 
            gxFrameColor: "name:darkMinty",
            gxFillColor: "name:darkMinty"
        }, 
    },

    "SliderKnob":
    {
		"+": "ImagePainter.sliderRound2.thumb",
		gxShadow: "{0.0, 0.0, 0.0, 0.7}, {0.0, -0.5}, 2.0", 
		"selected": {
			gxAddStyles: ["focused"]
		},
		"disabled": {
			gxShadow: null,
		}
    },

    "SliderPointy": {
        "+": "SliderView",
		gxViewFlipped: true,
        gxDetents: "0, 20, 40",
        gxLabelText: "",
        gxDetentPainter:  {
           "+" : "SliderDetents", 
           gxEdgeInsets: "0,28,0,5",
        },
        gxKnobPainter: {
            "+": "ImagePainter.sliderPointy2.thumb",
            gxShadow: "{0.0, 0.0, 0.0, 0.7}, {0.0, -0.5}, 2.0",
            gxEdgeInsets: "0,2,0,-2",  // used as offset, do not reduce size
            "selected": {
				gxAddStyles: ["focused"]
            },
            "disabled": {
                gxShadow: null,
            }
        },
    },
    
    "SliderDetents": {
        nsClass: GXPainter,
        gxFillColor: "name:darkGray",
        gxDefaultSize: "1,39",
        gxEdgeInsets: "0,25,0,10",
        "disabled": {
            gxFillColor: "name:lightGray"
        }
    },

    "SliderDetentsBig": {
        nsClass: GXPainter,
        gxFillColor: "name:darkGray",
        gxDefaultSize: "1,20",
        gxEdgeInsets: "0,0,0,0",
        "disabled": {
            gxFillColor: "name:lightGray"
        }
    },
})
