markup.push({
	// MARK: "Image view"
	
	"ImageView": {
		nsClass: GXImageView,
		"gxImagePainter": "ImagePainter",
	},
	
	// MARK: "label view"
	
	"LabelView": {
		nsClass: GXLabelView,
		gxForePainter: "LabelFore",
		gxDefaultValue: "12345",      // just so it has a size and something visible
		gxIntrinsicHeight: 16
	},
	
	"DescriptionLabelView": {
		"+": "LabelView.left.top.size11.wrap",
		axIsIgnored: false
	},
	
	// MARK: "list view"
	
	"ListView": {
		nsClass: GXListView,
		gxLayoutSubviews: true,
		gxCollapsible: false,
		gxLayoutHorizontally: false,
		gxCollapsed: false
	},
	
	// MARK: "scrollbar view"
	
	"ScrollBarView":
	{
		nsClass: GXScroller,
		axIsIgnored: true,
		gxKnobPainter: "ScrollBarKnob",
		gxMinKnobLength: 20
	},
	
	// MARK: "text view"
	
	"TextView": {
		"+": "BaseTextField",
		nsClass: GXTextView,
	},
	
	// MARK: "textfield view"
	
	"BaseTextField": {    // note: "code depends on the name 'BaseTextField' when looking up gxSelectionColor"
		nsClass: GXTextField,
		gxBaselineOffset: 2,
		//gxDisabledAlphaColor: "gray:255,28", // placed over everything when disabled
		gxInsertionPointColor: "name:fontColor",
		gxSelectionColor: "rgba:167,201,255,100",    // overrides system hilite color for user selection
		gxLabelTemplate: "LabelView.right.primary.size13",
		gxBackPainter: "TextFieldBack",
		gxPlaceholderStyle: "PlaceholderStyle",
		"gxTextPainter": "TextFieldFore",
	},

	"DisclosureButton" : {
		nsClass: "SoundSource.TCShowEffectsButton",
		axIsIgnored: true,
		gxIntrinsicHeight: 24,
		gxIntrinsicWidth: 24,
		gxBaselineOffset: 7,
		gxHideOnNilValue: true,
		gxTitle: "",
		gxBackPainter: {
			nsClass: GXRoundRectPainter,
			gxEdgeInsets: "2,2,2,2",
			gxFillColor: "name:controlBackFill",
			gxFrameColor: "name:fontColor",
			"disabled" : {
				gxFrameColor: "name:darkGray"
			}
		},
		gxForePainter: {
			nsClass: GXRoundRectPainter,
			gxFrameColor: "name:controlFrame",
			"disabled" : {
				gxFrameColor: "name:lightMinty"
			}
		},
	},

	"TextField": {
		"+": "BaseTextField"
	},

	"PlaceholderStyle": {
		nsClass: GXStyledString,
		gxFontSize: 12.3,
		gxFontColor: "name:darkGray"
	},


	"ImageBarButton": {  // images without border
		nsClass: GXButtonView,
		gxIntrinsicHeight: 24,
		gxIntrinsicWidth: 24,
	},

	"ButtonView": {
		nsClass: GXButtonView,
		gxIntrinsicHeight: 25,
		gxIntrinsicWidth: 60,
		gxBackPainter: "ControlBack",
		gxForePainter: "ControlFore"
	},

	// MARK: "window bits"

	"WindowTitle": {
		"+": "LabelView.light.size135",
		gxValueKeyPath: "window.title",
		gxIntrinsicWidth: -1,
		gxLayout: ["H:|-75-[self]-75-|", "V:|-3-[self]"],
		axIsIgnored: true
	},

	"WindowTitleBar": {
		nsClass: GXSettingsView,
		gxViewName: "titleBarView",
		gxBackPainter: "WindowTitleBarBack",
		gxIntrinsicWidth: -1,
		gxIntrinsicHeight: 23,
		gxCanDrawSubviewsIntoLayer: true,    // important for drawn text quality of title
		gxLayout: ["H:|[self]|",
		"V:|-(0@900)-[self]"],
		// constraint priority set so code can override. see GXWindow setupCustomTitlebar
		gxChildViews: {
			"title": "WindowTitle"
		},
	},

	"WindowTitleBarBack": {
		nsClass: GXRoundRectPainter,
		gxEdgeInsets: "-1.5,-2.5,-1.5,0",
		gxCornerRadii: "3, 3, 0, 0",
		gxFillColor: "name:white",
	},

	//MARK: "Panel Dividers"

	"PanelDivider": {
		nsClass: GXDrawView,
		gxIntrinsicHeight: 1,
		gxLayout: [
			"H:|-0-[self]-0-|"
		],
		gxBackPainter: "PanelDividerPainter",
	},

	"PanelDividerPainter" : {
		nsClass: GXPainter,            // GXPainter can only fill
		gxFillColor: "name:darkMinty"
	},

	//MARK: "Spinner"

	"Spinner": {
		nsClass: GXSpinnerView,
		gxValueKeyPath: "",
		gxFrameRect: "0,0,40,40",
		"gxSpinLayer": "SpinnerLayer"
	},
	"SpinnerLayer": {
		nsClass: "GXDrawLayer",
		gxFrameRect: "0,0,40,40",    // initial size sublayers are relative to
		gxForePainter: {
			"+": "ImagePainter.action.spinner",
			gxTintColor: "name:genericPluginPopoverFill",
		},
		"gxAnchorPoint": "0.5, 0.5",    // spin around center
		"gxOpacity": 0,    // start invisible}
	},

	// MARK: "formatters"
	"PercentageFormatter": { nsClass: "GXScaledFormatter", "scale": 100, "format": "% .0f%%" },

	"PopupMenuView": {
		nsClass: GXPopupMenuView,
		gxIntrinsicHeight: 25,
		gxForePainter: "PopupFore",
		gxBackPainter: "PopupMenuBack",
		gxForePainter: {
			"+": "ControlFore.size12.left",
			gxEdgeInsets: "5,2,0,0",
		},
		gxLayout: [
			"H:[selfLabel]-(5.0)-[self]&alignCenterY",
		],
		gxExtraPainter: "PopupArrows",
		gxLabelTemplate: {
			"+": "LabelView.right.fontColor.size13",
		},
		gxDisableOnNil: false        // menu item with repObject of null is valid, but doesn't mix with this setting. choose one.
	},

	"PopupMenuBack" : {
		"+": "PopupBack", 
		gxStrokeWidth: 1,
		gxEdgeInsets: "1.5, 1.5, 1.5, 1.5", // Inset for shadow
		gxShadow: "{0.58, 0.58, 0.58, 0.8}, {0.0, -0.30}, 1.5",
	},

	"FlatButtonPopup" : {
		"+" : "PopupMenuView",
		gxBackPainter: "FlatButtonBack",
		gxForePainter: "FlatButtonFore",
		gxExtraPainter: "FlatButtonExtra",
		"down": {
			gxExtraPainter: "FlatButtonExtra.down",
		},
		gxHideOnNilValue: true, 
		gxLayout: [
			"H:|-20-[self(100)]",
			"V:[self(24)]",
		],
		gxTitle: ""
	},

	"FlatButtonBack" : {
		"+" : "ControlBack", 
		gxStrokeWidth: 1,
		"green" : {
			gxFrameColor: "name:fullGreen",
			gxFillColor: "name:fullGreen",
		},
	},
	"FlatButtonFore" : {
		"+" : "ControlFore.size12.fontColor",
		"green" : {
			gxFontColor: "name:white"
		},
	},
	"FlatButtonExtra" : {
		"+" : "PopupArrows",
		"down" : {
			gxImage: "disclosure.open"
		},
		gxTintColor: "name:white",
	},

	// ---------------------------------
	// MARK: formatter: AX volume slider

	AXVolumeSliderFormatter:
	{
		nsClass: "GXScaledFormatter",
		scale: 100,
		format: "%.0f%%"
	},
	AXBalanceSliderFormatter:
	{
		nsClass: "GXScaledFormatter",
		scale: 100,
		format: "%.0f%%",
		zeroFormat: "0%%"
	},
	DesatOverlay: {
		nsClass: "SoundSource.TCDesatOverlay",
		gxIgnoreMouseClick: true,
		gxValueKeyPath: "",
		gxLayout: [
			"H:|[self]|",
			"V:|[self]|",
		],
		gxLayerZPosition: 100,
		gxBackPainter : "DesatOverlayBackPainter"
	},
	DesatOverlayBackPainter: {
		nsClass: GXRoundRectPainter ,
		gxFillColor	: null,
		"inactive" :{
			gxFillColor	: "name:desat"
		}
	},

	"AlertButton" : {
		"+" : "ButtonView",
		gxIntrinsicHeight: 30,
		gxIntrinsicWidth: 30,
		gxBaselineOffset: 11,
		gxLayerZPosition: 2,
		gxBackPainter: null,
		gxForePainter: {
			"+": "ControlFore.black",
		},
		gxTitle: Constants.warningIcon,
	},

})


